diff -Npur gnumach.old/ipc/ipc_object.c gnumach.new/ipc/ipc_object.c
--- gnumach.old/ipc/ipc_object.c	2001-05-11 19:34:13.000000000 -0300
+++ gnumach.new/ipc/ipc_object.c	2006-04-05 13:23:45.000000000 -0300
@@ -31,8 +31,6 @@
  *	Functions to manipulate IPC objects.
  */
 
-#include <mach_ipc_compat.h>
-
 #include <mach/boolean.h>
 #include <mach/kern_return.h>
 #include <mach/port.h>
@@ -366,14 +364,6 @@ ipc_object_copyin_type(
 	    case MACH_MSG_TYPE_COPY_SEND:
 		return MACH_MSG_TYPE_PORT_SEND;
 
-#if	MACH_IPC_COMPAT
-	    case MSG_TYPE_PORT:
-		return MACH_MSG_TYPE_PORT_SEND;
-
-	    case MSG_TYPE_PORT_ALL:
-		return MACH_MSG_TYPE_PORT_RECEIVE;
-#endif	/* MACH_IPC_COMPAT */
-
 	    default:
 #if MACH_ASSERT
 		assert(!"ipc_object_copyin_type: strange rights");
@@ -964,322 +954,6 @@ ipc_object_rename(
 	return kr;
 }
 
-#if	MACH_IPC_COMPAT
-
-/*
- *	Routine:	ipc_object_copyout_type_compat
- *	Purpose:
- *		Convert a carried type name to an old type name.
- */
-
-mach_msg_type_name_t
-ipc_object_copyout_type_compat(msgt_name)
-	mach_msg_type_name_t msgt_name;
-{
-	switch (msgt_name) {
-	    case MACH_MSG_TYPE_PORT_SEND:
-	    case MACH_MSG_TYPE_PORT_SEND_ONCE:
-		return MSG_TYPE_PORT;
-
-	    case MACH_MSG_TYPE_PORT_RECEIVE:
-		return MSG_TYPE_PORT_ALL;
-
-	    default:
-#if MACH_ASSERT
-		assert(!"ipc_object_copyout_type_compat: strange rights");
-#else
-		panic("ipc_object_copyout_type_compat: strange rights");
-#endif
-	}
-}
-
-/*
- *	Routine:	ipc_object_copyin_compat
- *	Purpose:
- *		Copyin a capability from a space.
- *		If successful, the caller gets a ref
- *		for the resulting object, which is always valid.
- *	Conditions:
- *		Nothing locked.
- *	Returns:
- *		KERN_SUCCESS		Acquired a valid object.
- *		KERN_INVALID_TASK	The space is dead.
- *		KERN_INVALID_NAME	Name doesn't exist in space.
- *		KERN_INVALID_RIGHT	Name doesn't denote correct right.
- */
-
-kern_return_t
-ipc_object_copyin_compat(space, name, msgt_name, dealloc, objectp)
-	ipc_space_t space;
-	mach_port_t name;
-	mach_msg_type_name_t msgt_name;
-	boolean_t dealloc;
-	ipc_object_t *objectp;
-{
-	ipc_entry_t entry;
-	kern_return_t kr;
-
-	kr = ipc_right_lookup_write(space, name, &entry);
-	if (kr != KERN_SUCCESS)
-		return kr;
-	/* space is write-locked and active */
-
-	kr = ipc_right_copyin_compat(space, name, entry,
-				     msgt_name, dealloc, objectp);
-	/* space is unlocked */
-	return kr;
-}
-
-/*
- *	Routine:	ipc_object_copyin_header
- *	Purpose:
- *		Copyin a capability from a space.
- *		If successful, the caller gets a ref
- *		for the resulting object, which is always valid.
- *		The type of the acquired capability is returned.
- *	Conditions:
- *		Nothing locked.
- *	Returns:
- *		KERN_SUCCESS		Acquired a valid object.
- *		KERN_INVALID_TASK	The space is dead.
- *		KERN_INVALID_NAME	Name doesn't exist in space.
- *		KERN_INVALID_RIGHT	Name doesn't denote correct right.
- */
-
-kern_return_t
-ipc_object_copyin_header(space, name, objectp, msgt_namep)
-	ipc_space_t space;
-	mach_port_t name;
-	ipc_object_t *objectp;
-	mach_msg_type_name_t *msgt_namep;
-{
-	ipc_entry_t entry;
-	kern_return_t kr;
-
-	kr = ipc_right_lookup_write(space, name, &entry);
-	if (kr != KERN_SUCCESS)
-		return kr;
-	/* space is write-locked and active */
-
-	kr = ipc_right_copyin_header(space, name, entry,
-				     objectp, msgt_namep);
-	/* space is unlocked */
-	return kr;
-}
-
-/*
- *	Routine:	ipc_object_copyout_compat
- *	Purpose:
- *		Copyout a capability, placing it into a space.
- *		If successful, consumes a ref for the object.
- *
- *		Marks new entries with IE_BITS_COMPAT.
- *	Conditions:
- *		Nothing locked.
- *	Returns:
- *		KERN_SUCCESS		Copied out object, consumed ref.
- *		KERN_INVALID_TASK	The space is dead.
- *		KERN_INVALID_CAPABILITY	The object is dead.
- *		KERN_NO_SPACE		No room in space for another right.
- *		KERN_RESOURCE_SHORTAGE	No memory available.
- */
-
-kern_return_t
-ipc_object_copyout_compat(space, object, msgt_name, namep)
-	ipc_space_t space;
-	ipc_object_t object;
-	mach_msg_type_name_t msgt_name;
-	mach_port_t *namep;
-{
-	mach_port_t name;
-	ipc_entry_t entry;
-	ipc_port_t port;
-	kern_return_t kr;
-
-	assert(IO_VALID(object));
-	assert(io_otype(object) == IOT_PORT);
-	port = (ipc_port_t) object;
-
-	is_write_lock(space);
-
-	for (;;) {
-		ipc_port_request_index_t request;
-
-		if (!space->is_active) {
-			is_write_unlock(space);
-			return KERN_INVALID_TASK;
-		}
-
-		if ((msgt_name != MACH_MSG_TYPE_PORT_SEND_ONCE) &&
-		    ipc_right_reverse(space, (ipc_object_t) port,
-				      &name, &entry)) {
-			/* port is locked and active */
-
-			assert(entry->ie_bits & MACH_PORT_TYPE_SEND_RECEIVE);
-			break;
-		}
-
-		kr = ipc_entry_get(space, &name, &entry);
-		if (kr != KERN_SUCCESS) {
-			/* unlocks/locks space, so must start again */
-
-			kr = ipc_entry_grow_table(space);
-			if (kr != KERN_SUCCESS)
-				return kr; /* space is unlocked */
-
-			continue;
-		}
-
-		assert(IE_BITS_TYPE(entry->ie_bits) == MACH_PORT_TYPE_NONE);
-		assert(entry->ie_object == IO_NULL);
-
-		ip_lock(port);
-		if (!ip_active(port)) {
-			ip_unlock(port);
-			ipc_entry_dealloc(space, name, entry);
-			is_write_unlock(space);
-			return KERN_INVALID_CAPABILITY;
-		}
-
-		kr = ipc_port_dnrequest(port, name, ipr_spacem(space),
-					&request);
-		if (kr != KERN_SUCCESS) {
-			ipc_entry_dealloc(space, name, entry);
-			is_write_unlock(space);
-
-			kr = ipc_port_dngrow(port);
-			/* port is unlocked */
-			if (kr != KERN_SUCCESS)
-				return kr;
-
-			is_write_lock(space);
-			continue;
-		}
-
-		is_reference(space); /* for dnrequest */
-		entry->ie_object = (ipc_object_t) port;
-		entry->ie_request = request;
-		entry->ie_bits |= IE_BITS_COMPAT;
-		break;
-	}
-
-	/* space is write-locked and active, port is locked and active */
-
-	kr = ipc_right_copyout(space, name, entry,
-			       msgt_name, TRUE, (ipc_object_t) port);
-	/* object is unlocked */
-	is_write_unlock(space);
-
-	if (kr == KERN_SUCCESS)
-		*namep = name;
-	return kr;
-}
-
-/*
- *	Routine:	ipc_object_copyout_name_compat
- *	Purpose:
- *		Copyout a capability, placing it into a space.
- *		The specified name is used for the capability.
- *		If successful, consumes a ref for the object.
- *
- *		Like ipc_object_copyout_name, except that
- *		the name can't be in use at all, even for the same
- *		port, and IE_BITS_COMPAT gets turned on.
- *	Conditions:
- *		Nothing locked.
- *	Returns:
- *		KERN_SUCCESS		Copied out object, consumed ref.
- *		KERN_INVALID_TASK	The space is dead.
- *		KERN_INVALID_CAPABILITY	The object is dead.
- *		KERN_RESOURCE_SHORTAGE	No memory available.
- *		KERN_RIGHT_EXISTS	Space has rights under another name.
- *		KERN_NAME_EXISTS	Name is already used.
- */
-
-kern_return_t
-ipc_object_copyout_name_compat(space, object, msgt_name, name)
-	ipc_space_t space;
-	ipc_object_t object;
-	mach_msg_type_name_t msgt_name;
-	mach_port_t name;
-{
-	ipc_entry_t entry;
-	ipc_port_t port;
-	kern_return_t kr;
-
-	assert(IO_VALID(object));
-	assert(io_otype(object) == IOT_PORT);
-	port = (ipc_port_t) object;
-
-	for (;;) {
-		mach_port_t oname;
-		ipc_entry_t oentry;
-		ipc_port_request_index_t request;
-
-		kr = ipc_entry_alloc_name(space, name, &entry);
-		if (kr != KERN_SUCCESS)
-			return kr;
-		/* space is write-locked and active */
-
-		if (ipc_right_inuse(space, name, entry))
-			return KERN_NAME_EXISTS; /* space is unlocked */
-
-		assert(IE_BITS_TYPE(entry->ie_bits) == MACH_PORT_TYPE_NONE);
-		assert(entry->ie_object == IO_NULL);
-
-		if ((msgt_name != MACH_MSG_TYPE_PORT_SEND_ONCE) &&
-		    ipc_right_reverse(space, (ipc_object_t) port,
-				      &oname, &oentry)) {
-			/* port is locked and active */
-
-			ip_unlock(port);
-			ipc_entry_dealloc(space, name, entry);
-			is_write_unlock(space);
-			return KERN_RIGHT_EXISTS;
-		}
-
-		ip_lock(port);
-		if (!ip_active(port)) {
-			ip_unlock(port);
-			ipc_entry_dealloc(space, name, entry);
-			is_write_unlock(space);
-			return KERN_INVALID_CAPABILITY;
-		}
-
-		kr = ipc_port_dnrequest(port, name, ipr_spacem(space),
-					&request);
-		if (kr != KERN_SUCCESS) {
-			ipc_entry_dealloc(space, name, entry);
-			is_write_unlock(space);
-
-			kr = ipc_port_dngrow(port);
-			/* port is unlocked */
-			if (kr != KERN_SUCCESS)
-				return kr;
-
-			continue;
-		}
-
-		is_reference(space); /* for dnrequest */
-		entry->ie_object = (ipc_object_t) port;
-		entry->ie_request = request;
-		entry->ie_bits |= IE_BITS_COMPAT;
-		break;
-	}
-
-	/* space is write-locked and active, port is locked and active */
-
-	kr = ipc_right_copyout(space, name, entry,
-			       msgt_name, TRUE, (ipc_object_t) port);
-	/* object is unlocked */
-	is_write_unlock(space);
-
-	assert(kr == KERN_SUCCESS);
-	return kr;
-}
-
-#endif	/* MACH_IPC_COMPAT */
-
 #include <mach_kdb.h>
 
 
diff -Npur gnumach.old/ipc/ipc_object.h gnumach.new/ipc/ipc_object.h
--- gnumach.old/ipc/ipc_object.h	2001-04-05 03:39:19.000000000 -0300
+++ gnumach.new/ipc/ipc_object.h	2006-04-05 13:22:38.000000000 -0300
@@ -34,8 +34,6 @@
 #ifndef	_IPC_IPC_OBJECT_H_
 #define _IPC_IPC_OBJECT_H_
 
-#include <mach_ipc_compat.h>
-
 #include <mach/kern_return.h>
 #include <mach/message.h>
 #include <kern/lock.h>
@@ -162,30 +160,6 @@ ipc_object_copyout_dest(/* ipc_space_t, 
 extern kern_return_t
 ipc_object_rename(/* ipc_space_t, mach_port_t, mach_port_t */);
 
-#if	MACH_IPC_COMPAT
-
-extern mach_msg_type_name_t
-ipc_object_copyout_type_compat(/* mach_msg_type_name_t */);
-
-extern kern_return_t
-ipc_object_copyin_compat(/* ipc_space_t, mach_port_t,
-			    mach_msg_type_name_t, boolean_t,
-			    ipc_object_t * */);
-
-extern kern_return_t
-ipc_object_copyin_header(/* ipc_space_t, mach_port_t,
-			    ipc_object_t *, mach_msg_type_name_t * */);
-
-extern kern_return_t
-ipc_object_copyout_compat(/* ipc_space_t, ipc_object_t,
-			     mach_msg_type_name_t, mach_port_t * */);
-
-extern kern_return_t
-ipc_object_copyout_name_compat(/* ipc_space_t, ipc_object_t,
-				  mach_msg_type_name_t, mach_port_t */);
-
-#endif	/* MACH_IPC_COMPAT */
-
 extern void
 ipc_object_print(/* ipc_object_t */);
 
diff -Npur gnumach.old/ipc/ipc_port.c gnumach.new/ipc/ipc_port.c
--- gnumach.old/ipc/ipc_port.c	2006-03-20 08:31:36.000000000 -0300
+++ gnumach.new/ipc/ipc_port.c	2006-04-05 13:36:55.000000000 -0300
@@ -34,8 +34,6 @@
  *	Functions to manipulate IPC ports.
  */
 
-#include <mach_ipc_compat.h>
-
 #include <mach/port.h>
 #include <mach/kern_return.h>
 #include <kern/lock.h>
@@ -569,55 +567,6 @@ ipc_port_alloc_name(
 	return KERN_SUCCESS;
 }
 
-#if	MACH_IPC_COMPAT
-/*
- *	Routine:	ipc_port_delete_compat
- *	Purpose:
- *		Find and destroy a compat entry for a dead port.
- *		If successful, generate a port-deleted notification.
- *	Conditions:
- *		Nothing locked; the port is dead.
- *		Frees a ref for the space.
- */
-
-void
-ipc_port_delete_compat(port, space, name)
-	ipc_port_t port;
-	ipc_space_t space;
-	mach_port_t name;
-{
-	ipc_entry_t entry;
-	kern_return_t kr;
-
-	assert(!ip_active(port));
-
-	kr = ipc_right_lookup_write(space, name, &entry);
-	if (kr == KERN_SUCCESS) {
-		ipc_port_t sright;
-
-		/* space is write-locked and active */
-
-		if ((ipc_port_t) entry->ie_object == port) {
-			assert(entry->ie_bits & IE_BITS_COMPAT);
-
-			sright = ipc_space_make_notify(space);
-
-			kr = ipc_right_destroy(space, name, entry);
-			/* space is unlocked */
-			assert(kr == KERN_INVALID_NAME);
-		} else {
-			is_write_unlock(space);
-			sright = IP_NULL;
-		}
-
-		if (IP_VALID(sright))
-			ipc_notify_port_deleted_compat(sright, name);
-	}
-
-	is_release(space);
-}
-#endif	/* MACH_IPC_COMPAT */
-
 /*
  *	Routine:	ipc_port_destroy
  *	Purpose:
@@ -661,28 +610,6 @@ ipc_port_destroy(
 		port->ip_destination = IP_NULL;
 		ip_unlock(port);
 
-#if	MACH_IPC_COMPAT
-		/*
-		 *	pdrequest might actually be a send right instead
-		 *	of a send-once right, indicated by the low bit
-		 *	of the pointer value.  If this is the case,
-		 *	we must use ipc_notify_port_destroyed_compat.
-		 */
-
-		if (ip_pdsendp(pdrequest)) {
-			ipc_port_t sright = ip_pdsend(pdrequest);
-
-			if (!ipc_port_check_circularity(port, sright)) {
-				/* consumes our refs for port and sright */
-				ipc_notify_port_destroyed_compat(sright, port);
-				return;
-			} else {
-				/* consume sright and destroy port */
-				ipc_port_release_send(sright);
-			}
-		} else
-#endif	/* MACH_IPC_COMPAT */
-
 		if (!ipc_port_check_circularity(port, pdrequest)) {
 			/* consumes our refs for port and pdrequest */
 			ipc_notify_port_destroyed(pdrequest, port);
@@ -770,14 +697,6 @@ ipc_port_destroy(
 			soright = ipr->ipr_soright;
 			assert(soright != IP_NULL);
 
-#if	MACH_IPC_COMPAT
-			if (ipr_spacep(soright)) {
-				ipc_port_delete_compat(port,
-						ipr_space(soright), name);
-				continue;
-			}
-#endif	/* MACH_IPC_COMPAT */
-
 			ipc_notify_dead_name(soright, name);
 		}
 
@@ -1275,165 +1194,6 @@ ipc_port_dealloc_special(
 	ipc_port_destroy(port);
 }
 
-#if	MACH_IPC_COMPAT
-
-/*
- *	Routine:	ipc_port_alloc_compat
- *	Purpose:
- *		Allocate a port.
- *	Conditions:
- *		Nothing locked.  If successful, the port is returned
- *		locked.  (The caller doesn't have a reference.)
- *
- *		Like ipc_port_alloc, except that the new entry
- *		is IE_BITS_COMPAT.
- *	Returns:
- *		KERN_SUCCESS		The port is allocated.
- *		KERN_INVALID_TASK	The space is dead.
- *		KERN_NO_SPACE		No room for an entry in the space.
- *		KERN_RESOURCE_SHORTAGE	Couldn't allocate memory.
- */
-
-kern_return_t
-ipc_port_alloc_compat(space, namep, portp)
-	ipc_space_t space;
-	mach_port_t *namep;
-	ipc_port_t *portp;
-{
-	ipc_port_t port;
-	ipc_entry_t entry;
-	mach_port_t name;
-	ipc_table_size_t its;
-	ipc_port_request_t table;
-	ipc_table_elems_t size;
-	ipc_port_request_index_t free, i;
-	kern_return_t kr;
-
-	port = ip_alloc();
-	if (port == IP_NULL)
-		return KERN_RESOURCE_SHORTAGE;
-
-	its = &ipc_table_dnrequests[0];
-	table = it_dnrequests_alloc(its);
-	if (table == IPR_NULL) {
-		ip_free(port);
-		return KERN_RESOURCE_SHORTAGE;
-	}
-
-	kr = ipc_entry_alloc(space, &name, &entry);
-	if (kr != KERN_SUCCESS) {
-		ip_free(port);
-		it_dnrequests_free(its, table);
-		return kr;
-	}
-	/* space is write-locked */
-
-	entry->ie_object = (ipc_object_t) port;
-	entry->ie_request = 1;
-	entry->ie_bits |= IE_BITS_COMPAT|MACH_PORT_TYPE_RECEIVE;
-
-	ip_lock_init(port);
-	ip_lock(port);
-	is_write_unlock(space);
-
-	port->ip_references = 1; /* for entry, not caller */
-	port->ip_bits = io_makebits(TRUE, IOT_PORT, 0);
-
-	ipc_port_init(port, space, name);
-
-	size = its->its_size;
-	assert(size > 1);
-	free = 0;
-
-	for (i = 2; i < size; i++) {
-		ipc_port_request_t ipr = &table[i];
-
-		ipr->ipr_name = MACH_PORT_NULL;
-		ipr->ipr_next = free;
-		free = i;
-	}
-
-	table->ipr_next = free;
-	table->ipr_size = its;
-	port->ip_dnrequests = table;
-
-	table[1].ipr_name = name;
-	table[1].ipr_soright = ipr_spacem(space);
-	is_reference(space);
-
-	*namep = name;
-	*portp = port;
-	return KERN_SUCCESS;
-}
-
-/*
- *	Routine:	ipc_port_copyout_send_compat
- *	Purpose:
- *		Copyout a naked send right (possibly null/dead),
- *		or if that fails, destroy the right.
- *		Like ipc_port_copyout_send, except that if a
- *		new translation is created it has the compat bit.
- *	Conditions:
- *		Nothing locked.
- */
-
-mach_port_t
-ipc_port_copyout_send_compat(sright, space)
-	ipc_port_t sright;
-	ipc_space_t space;
-{
-	mach_port_t name;
-
-	if (IP_VALID(sright)) {
-		kern_return_t kr;
-
-		kr = ipc_object_copyout_compat(space, (ipc_object_t) sright,
-					       MACH_MSG_TYPE_PORT_SEND, &name);
-		if (kr != KERN_SUCCESS) {
-			ipc_port_release_send(sright);
-			name = MACH_PORT_NULL;
-		}
-	} else
-		name = (mach_port_t) sright;
-
-	return name;
-}
-
-/*
- *	Routine:	ipc_port_copyout_receiver
- *	Purpose:
- *		Copyout a port reference (possibly null)
- *		by giving the caller his name for the port,
- *		if he is the receiver.
- *	Conditions:
- *		Nothing locked.  Consumes a ref for the port.
- */
-
-mach_port_t
-ipc_port_copyout_receiver(port, space)
-	ipc_port_t port;
-	ipc_space_t space;
-{
-	mach_port_t name;
-
-	if (!IP_VALID(port))
-		return MACH_PORT_NULL;
-
-	ip_lock(port);
-	if (port->ip_receiver == space) {
-		name = port->ip_receiver_name;
-		assert(MACH_PORT_VALID(name));
-	} else
-		name = MACH_PORT_NULL;
-
-	ip_release(port);
-	ip_check_unlock(port);
-
-	return name;
-}
-
-#endif	/* MACH_IPC_COMPAT */
-
 #include <mach_kdb.h>
 
 
diff -Npur gnumach.old/ipc/ipc_port.h gnumach.new/ipc/ipc_port.h
--- gnumach.old/ipc/ipc_port.h	2006-03-20 08:31:36.000000000 -0300
+++ gnumach.new/ipc/ipc_port.h	2006-04-05 13:20:22.000000000 -0300
@@ -39,8 +39,6 @@
 #ifndef	_IPC_IPC_PORT_H_
 #define _IPC_IPC_PORT_H_
 
-#include <mach_ipc_compat.h>
-
 #include <mach/boolean.h>
 #include <mach/kern_return.h>
 #include <mach/port.h>
@@ -150,30 +148,6 @@ typedef struct ipc_port_request {
 
 #define	IPR_NULL		((ipc_port_request_t) 0)
 
-#if	MACH_IPC_COMPAT
-/*
- *	For backwards compatibility, the ip_pdrequest field can hold a
- *	send right instead of a send-once right.  This is indicated by
- *	the low bit of the pointer.  This works because the zone package
- *	guarantees that the two low bits of port pointers are zero.
- */
-
-#define	ip_pdsendp(soright)	((unsigned int)(soright) & 1)
-#define ip_pdsend(soright)	((ipc_port_t)((unsigned int)(soright) &~ 1))
-#define	ip_pdsendm(sright)	((ipc_port_t)((unsigned int)(sright) | 1))
-
-/*
- *	For backwards compatibility, the ipr_soright field can hold
- *	a space pointer.  This is indicated by the low bit of the pointer.
- *	This works because the zone package guarantees that the two low
- *	bits of port and space pointers are zero.
- */
-
-#define	ipr_spacep(soright)	((unsigned int)(soright) & 1)
-#define ipr_space(soright)	((ipc_space_t)((unsigned int)(soright) &~ 1))
-#define	ipr_spacem(space)	((ipc_port_t)((unsigned int)(space) | 1))
-#endif	/* MACH_IPC_COMPAT */
-
 /*
  *	Taking the ipc_port_multiple lock grants the privilege
  *	to lock multiple ports at once.  No ports must locked
@@ -351,19 +325,6 @@ ipc_port_dealloc_special(/* ipc_port_t *
 #define	ipc_port_release(port)		\
 		ipc_object_release(&(port)->ip_object)
 
-#if	MACH_IPC_COMPAT
-
-extern kern_return_t
-ipc_port_alloc_compat(/* ipc_space_t, mach_port_t *, ipc_port_t * */);
-
-extern mach_port_t
-ipc_port_copyout_send_compat(/* ipc_port_t, ipc_space_t */);
-
-extern mach_port_t
-ipc_port_copyout_receiver(/* ipc_port_t, ipc_space_t */);
-
-#endif	/* MACH_IPC_COMPAT */
-
 extern void
 ipc_port_print(/* ipc_port_t */);
 
